<template>
  <v-menu
    v-model="menu"
    :close-on-content-click="false"
    :nudge-right="40"
    transition="scale-transition"
    offset-y
    min-width="290px"
  >
    <template #activator="{ on }">
      <GTextField
        v-model="date"
        :validate="validate"
        :label="label"
        :i18n="i18n"
        prepend-icon="event"
        readonly
        v-on="on"
      />
    </template>
    <v-date-picker
      v-model="date"
      v-bind="$attrs"
      no-title
      scrollable
      :locale="$i18n.locale"
      :first-day-of-week="firstDayOfWeek"
      @input="menu = false"
    >
      <v-btn text color="error" @click="clearDate">
        {{ $t("form.clear") }}
      </v-btn>
    </v-date-picker>
  </v-menu>
</template>

<script>
import GTextField from "./gTextField";

export default {
  name: "GStringDatePicker",
  components: { GTextField },
  inheritAttrs: true,
  props: { value: String, label: String, i18n: String, validate: String },
  data() {
    return {
      menu: false,
    };
  },
  computed: {
    date: {
      get() {
        return this.value;
      },
      set(date) {
        this.$emit("input", date);
      },
    },
    firstDayOfWeek() {
      return parseInt(this.$t("lang.firstDayOfWeek"));
    },
  },
  methods: {
    clearDate() {
      this.date = "";
      this.menu = false;
    },
  },
};
</script>
